#<profile4xi profile = "10" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "reduce_socket4xi.py">
#<abstract4xi abstract = "providing function reduce_socket4xi"/>
#<refer4xi reference = "reduction.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = "  
__all__ = [ 'reduce_socket4xi' ]
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
    import socket
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:
    import _winapi
except:
    pass

                
try:                 # most-common ones
    import traceback         
except:
    pass
#"
#/>


# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
try:                             # Binary ones
    import _multiprocessing
except:
    pass
try:                             # Python ones
    from multiprocessing.reduction import reduce_socket
except:
    print("reduce_socket4xi.py: *** failed in from multiprocessing.reduction import reduce_socket ***")
#"
#/>


# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
try:
    from rebuild_socket4xi import rebuild_socket4xi
except:
    print('** [NACK] in reduce_socket4xi.py: from rebuild_socket4xi import rebuild_socket4xi **')
try:
    from dupsocket4xi import DupSocket4Xi
except:
    print('** [NACK] in reduce_socket4xi.py: from dupsocket4xi import DupSocket4Xi **')
try:
    from dupfd4xi import DupFd4Xi 
except:
    print('** [NACK] in reduce_socket4xi.py: from dupfd4xi import DupFd4Xi  **') 
     
from print4xi import print4xi
from time4xi import time4xi
#"
#/>

 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "reduce_socket4xi" usage = "
#   reduce_socket4xi(socket)
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def reduce_socket4xi(socket):
    '''
    reduce_socket4xi in reduction.py by reduce_connection function: rh = reduce_socket(conn.fileno())
    '''
       
    class2print = "reduce_socket4xi"
    method2print = "reduce_socket4xi"
            
    if sys.platform == 'win32':
        # -----------------------------------------------------------------------------------------    
        # (Step 1/3) - Windows
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 1/3a) started" + "; reduce-socket4xi-started: " + str(reduce_socket4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
            
        message2print = "{(Step 1/3b) passed" + "; socket-passed-to-reduce-socket4xi: " + str(socket) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
                
        # -----------------------------------------------------------------------------------------    
        # (Step 2/3)
        # -----------------------------------------------------------------------------------------        
        socket2xi = None              
        try:
            socket2xi = rebuild_socket4xi, (DupSocket4Xi(socket),)
            
            message2print = "{(Step 2/3a) got" + "; socket2xi-got-by-reduce-socket4xi: " + str(socket2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            
        except:
            message2print = "{(Step 2/3z) failed" + "; socket2xi-failed-by-reduce-socket4xi: " + str(socket2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            
                
        # -----------------------------------------------------------------------------------------    
        # (Step 3/3)
        # -----------------------------------------------------------------------------------------        
        message2print = "{(Step 3/3) returning" + "; socket2xi-returning-by-reduce-socket4xi: " + str(socket2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)   
        #            
        
        return socket2xi
    else:
        # -----------------------------------------------------------------------------------------    
        # (Step 1/3) - non-Windows
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 1/3a) started" + "; reduce-socket4xi-started: " + str(reduce_socket4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
            
        message2print = "{(Step 1/3b) passed" + "; socket-passed-to-reduce-socket4xi: " + str(socket) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        
        # -----------------------------------------------------------------------------------------    
        # (Step 2/3) - non-Windows
        # -----------------------------------------------------------------------------------------        
        df2xi = None                         
        try:
            df2xi = DupFd4Xi(socket.fileno())
            message2print = "{(Step 2/3a) got" + "; df2xi-got-by-reduce-socket4xi: " + str(df2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            
            message2print = "{(Step 2/3b) passing" + "; family-passing-to-rebuild_socket4xi: " + str(socket.family) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #
            message2print = "{(Step 2/3c) passing" + "; type-passing-to-rebuild_socket4xi: " + str(socket.type) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            message2print = "{(Step 2/3d) passing" + "; proto-passing-to-rebuild_socket4xi: " + str(socket.proto) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #  

            
            return rebuild_socket4xi, (df2xi, socket.family, socket.type, socket.proto)
                         
        except:
            message2print = "{(Step 2/3z1) failed" + "; df2xi-failed-by-reduce-socket4xi: " + str(df2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
        
                       
            return reduce_socket(socket)
            
            
#</function4xi>
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_none4xi.txt
#   sense-test-none4xi.xml
#   reason-test-none4xi.xml
#   ace-test-none4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of reduce_socket4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>

